package jp.flashcast.translator.android;

import java.util.ArrayList;

import jp.flashcast.translator.android.adapter.TranslateAdapter;
import jp.flashcast.translator.android.dao.TranslateDao;
import jp.flashcast.translator.android.manager.HistoryManager;
import jp.flashcast.translator.android.model.TranslateModel;
import jp.flashcast.translator.android.view.TranslateListView;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;

public class TranslatorSample6 extends Activity {
	private TranslateAdapter adapter;
	private TranslateDao dao;
	private HistoryManager manager;
	private int max;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        
        ArrayList<TranslateModel> arr = new ArrayList<TranslateModel>();
		dao = new TranslateDao(this);
		manager = new HistoryManager(dao);
        adapter = new TranslateAdapter(this, arr, manager);
        
        manager.setPage(0);
        max = manager.getHistoriesCount();
        int len = manager.setTranslateAdapter(adapter, false);
        
        TranslateListView list = (TranslateListView)findViewById(R.id.histories);
        list.addFooterView(getLayoutInflater().inflate(R.layout.footer, null));
        list.setAdapter(adapter);
        list.setEmptyView(findViewById(R.id.message));
        list.setFooterVisible(!(len == max));
        list.setOnItemClickListener(new OnItemClickListener() {

			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
				TranslateListView list = ((TranslateListView)findViewById(R.id.histories));
				
				if (list.isFooterVisible()) {
					if (position == (parent.getCount() - 1)) {
						manager.setPage(manager.getPage() + 1);
				        max = manager.getHistoriesCount();
						int len = manager.setTranslateAdapter(adapter, false);
						int pos = HistoryManager.HISTORY_LIST_VIEW_COUNT * (manager.getPage() - 1);
						list.setFooterVisible(!(len == max));
						list.setSelection((max > pos) ? pos : max);
					}
				}
			}
        	
        });
    }
}