package jp.flashcast.translator.android.dao;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.provider.BaseColumns;
import jp.flashcast.translator.android.manager.ConnectionManager;
import jp.flashcast.translator.android.model.TranslateModel;
import jp.flashcast.translator.android.schema.ITranslate;

public class TranslateDao {
	private ConnectionManager connection;
	
	public TranslateDao(Context context) {
		if (connection == null) {
			connection = ConnectionManager.getInstance(context);
		}
	}
	
	public void insert(TranslateModel model) {
		SQLiteDatabase db = connection.getWritableDatabase();
		db.insertOrThrow(ITranslate.TABLE_NAME, null, setValues(model));
		db.close();
	}
	
	private ContentValues setValues(TranslateModel model) {
		ContentValues values = new ContentValues(5);
		values.put(ITranslate.ORIGINAL, model.getOriginal());
		values.put(ITranslate.TRANSLATED, model.getTranslated());
		values.put(ITranslate.SRC_LANGUAGE, model.getSrcLanguage());
		values.put(ITranslate.DST_LANGUAGE, model.getDstLanguage());
		values.put(ITranslate.DATE_TIME, model.getDt());
		
		return values;
	}
	
	public void delete(int id) {
		SQLiteDatabase db = connection.getWritableDatabase();
		db.delete(ITranslate.TABLE_NAME, BaseColumns._ID + " = " + String.valueOf(id), null);
		db.close();
	}
	
	public Cursor find(String[] columns, String order, String limit) {
		SQLiteDatabase db = connection.getWritableDatabase();
		Cursor cursor = db.query(false, ITranslate.TABLE_NAME, columns, null, null, null, null, order, limit);
		
		return cursor;
	}
}
