package jp.flashcast.translator.android.manager;

import android.database.Cursor;
import android.provider.BaseColumns;
import jp.flashcast.translator.android.adapter.TranslateAdapter;
import jp.flashcast.translator.android.dao.TranslateDao;
import jp.flashcast.translator.android.model.TranslateModel;

public class HistoryManager {
	private TranslateDao dao;
	private int page;
	public final static int HISTORY_LIST_VIEW_COUNT = 2;

	public HistoryManager(TranslateDao dao) {
		this.dao = dao;
	}

	public void setPage(int page) {
		this.page = page;
	}

	public int getPage() {
		return page;
	}
	
    public int getHistoriesCount() {
 		int count = 0;
 		
    	Cursor cursor = dao.find(new String[] {"count(*)"}, null, null);
    	
 		if (cursor != null) {
 			if (cursor.getCount() == 1) {
 				cursor.moveToFirst();
 				count = cursor.getInt(0);
 			}
 		}
 		
		cursor.close();
		
 		return count;
    }
    
    public int setTranslateAdapter(TranslateAdapter adapter, boolean reset) {
    	if (reset) {
    		adapter.clear();
    	}
    	
    	Cursor cursor = getHistories(reset);
    	
    	addTranslateModel(adapter, cursor);
		
		cursor.close();
		
		return adapter.getCount();
    }

    private Cursor getHistories(boolean reset) {
    	String order = BaseColumns._ID + " DESC limit ";
    	
    	if (reset) {
    		order = order + String.valueOf(HISTORY_LIST_VIEW_COUNT * (page + 1));
    	}
    	else {
    		order = order + String.valueOf(HISTORY_LIST_VIEW_COUNT) + " offset " +
    			String.valueOf(HISTORY_LIST_VIEW_COUNT * page); 
    	}
    	
    	return dao.find(null, order, null);
    }
    
    private void addTranslateModel(TranslateAdapter adapter, Cursor cursor) {
		if (cursor != null) {
			if (cursor.getCount() > 0) {
				while (cursor.moveToNext()) {
					TranslateModel model = new TranslateModel();
					model.setId(cursor.getInt(0));
					model.setOriginal(cursor.getString(1));
					model.setTranslated(cursor.getString(2));
					model.setSrcLanguage(cursor.getString(3));
					model.setDstLanguage(cursor.getString(4));
					model.setDt(cursor.getString(5));
					adapter.add(model);
				}
			}
		}
    }
    
    public void delete(int id) {
    	dao.delete(id);
    }
}
