package jp.flashcast.translator.android.view;

import android.content.Context;
import android.util.AttributeSet;
import android.view.View;
import android.widget.ImageView;
import android.widget.ListView;
import jp.flashcast.translator.android.R;

public class TranslateListView extends ListView {
	private View footer;
	private boolean visible;
	
	public TranslateListView(Context context, AttributeSet attrs) {
		super(context, attrs);
	}

	@Override
	public void addFooterView(View footer) {
		super.addFooterView(footer);
		
		if (this.footer != null) {
			removeFooterView(this.footer);
		}
		
		this.footer = footer;
        ImageView img = (ImageView)this.footer.findViewById(R.id.more);
        img.setImageResource(android.R.drawable.ic_menu_more);
	}
	
	public void setFooterVisible(boolean visible) {
		if (this.footer != null) {
			if (!visible) {
				removeFooterView(this.footer);
			}
		}
		
		this.visible = visible;
	}
	
	public boolean isFooterVisible() {
		return this.visible;
	}
}
